import { ProxyPropertyKey } from './shared';
import { ReactiveMembrane } from './reactive-membrane';
export declare type ReactiveMembraneShadowTarget = object;
export declare abstract class BaseProxyHandler {
    originalTarget: any;
    membrane: ReactiveMembrane;
    constructor(membrane: ReactiveMembrane, value: any);
    abstract wrapValue(value: any): any;
    abstract wrapGetter(originalGet: () => any): () => any;
    abstract wrapSetter(originalSet: (v: any) => void): (v: any) => void;
    wrapDescriptor(descriptor: PropertyDescriptor): PropertyDescriptor;
    copyDescriptorIntoShadowTarget(shadowTarget: ReactiveMembraneShadowTarget, key: ProxyPropertyKey): void;
    lockShadowTarget(shadowTarget: ReactiveMembraneShadowTarget): void;
    abstract set(shadowTarget: ReactiveMembraneShadowTarget, key: ProxyPropertyKey, value: any): boolean;
    abstract deleteProperty(shadowTarget: ReactiveMembraneShadowTarget, key: ProxyPropertyKey): boolean;
    abstract setPrototypeOf(shadowTarget: ReactiveMembraneShadowTarget, prototype: any): any;
    abstract preventExtensions(shadowTarget: ReactiveMembraneShadowTarget): boolean;
    abstract defineProperty(shadowTarget: ReactiveMembraneShadowTarget, key: ProxyPropertyKey, descriptor: PropertyDescriptor): boolean;
    apply(shadowTarget: ReactiveMembraneShadowTarget, thisArg: any, argArray: any[]): void;
    construct(shadowTarget: ReactiveMembraneShadowTarget, argArray: any, newTarget?: any): any;
    get(shadowTarget: ReactiveMembraneShadowTarget, key: ProxyPropertyKey): any;
    has(shadowTarget: ReactiveMembraneShadowTarget, key: ProxyPropertyKey): boolean;
    ownKeys(shadowTarget: ReactiveMembraneShadowTarget): ProxyPropertyKey[];
    isExtensible(shadowTarget: ReactiveMembraneShadowTarget): boolean;
    getPrototypeOf(shadowTarget: ReactiveMembraneShadowTarget): object;
    getOwnPropertyDescriptor(shadowTarget: ReactiveMembraneShadowTarget, key: ProxyPropertyKey): PropertyDescriptor | undefined;
}
