import { ProxyPropertyKey } from './shared';
export declare type ReactiveMembraneAccessCallback = (obj: any, key: ProxyPropertyKey) => void;
export declare type ReactiveMembraneMutationCallback = (obj: any, key: ProxyPropertyKey) => void;
export declare type ReactiveMembraneDistortionCallback = (value: any) => any;
export declare type ReactiveMembraneObservableCallback = (value: any) => boolean;
export interface ObservableMembraneInit {
    valueMutated?: ReactiveMembraneMutationCallback;
    valueObserved?: ReactiveMembraneAccessCallback;
    valueDistortion?: ReactiveMembraneDistortionCallback;
    valueIsObservable?: ReactiveMembraneObservableCallback;
    tagPropertyKey?: ProxyPropertyKey;
}
export declare class ReactiveMembrane {
    valueDistortion: ReactiveMembraneDistortionCallback;
    valueMutated: ReactiveMembraneMutationCallback;
    valueObserved: ReactiveMembraneAccessCallback;
    valueIsObservable: ReactiveMembraneObservableCallback;
    tagPropertyKey: ProxyPropertyKey | undefined;
    private readOnlyObjectGraph;
    private reactiveObjectGraph;
    constructor(options?: ObservableMembraneInit);
    getProxy(value: any): any;
    getReadOnlyProxy(value: any): any;
    unwrapProxy(p: any): any;
    private getReactiveHandler;
    private getReadOnlyHandler;
}
